/*Talking Skeleton Code by Jamie Mayes 2021 
 * controls servo and DFPlayer Mini to trigger sound files
 * on a basic loop with 2 seconds between each sound
 */
 
//include some librarys
#include <Servo.h>
#include "SoftwareSerial.h"
#include "Arduino.h"
#include "DFRobotDFPlayerMini.h"

//setup software serial and dfplayer
SoftwareSerial mySoftwareSerial(10, 11); // RX, TX
DFRobotDFPlayerMini myDFPlayer;
void printDetail(uint8_t type, int value);

//define the eye led pin
int eyes = 3;

//create the servo object
Servo myservo;  // create servo object to control a servo

void setup() {
  pinMode (eyes, OUTPUT); //SET LED PIN AS OUTPUT
  myservo.attach(2);  // attaches the servo on pin 2 to the servo object
  
  mySoftwareSerial.begin(9600); //START SOFTWARE SERIAL FOR DFPLAYER  
  if (!myDFPlayer.begin(mySoftwareSerial)) {  //Use softwareSerial to communicate with mp3.
    while(true);
  }
  myDFPlayer.setTimeOut(500); //Set serial communictaion time out 500ms
  myDFPlayer.volume(30);  //Set volume value (0~30). SET TO MAX
}

void loop() {
delay(2000); //WAIT 2 SECS
one(); //PLAY HELLO SOUND 2 ON THE DFPLAYER 
delay(2000); //WAIT 2 SECS
two(); //PLAY HELLO SOUND 3 ON THE DFPLAYER 
delay(2000); //WAIT 2 SECS
three(); //PLAY HELLO SOUND 4 ON THE DFPLAYER 
}

void one(){
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION
    digitalWrite(eyes,HIGH);          //TURN ON THE EYES
    myDFPlayer.play(1);               //Play the first mp3
    myservo.write(50);                //SET SERVO TO MOUTH OPEN POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(10);                //SET SERVO TO SLIGHTY MOUTH OPEN POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(50);                //SET SERVO TO MOUTH OPEN POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION
    digitalWrite(eyes,LOW);           //TURN OFF THE EYES
    }

void two(){
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION  
    digitalWrite(eyes,HIGH);          //TURN OFF THE EYES
    myDFPlayer.play(2);               //Play the second mp3
    myservo.write(50);                //SET SERVO TO MOUTH OPEN POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(10);                //SET SERVO TO MOUTH SLIGHTLY OPEN POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(50);                //SET SERVO TO MOUTH OPEN POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(10);                //SET SERVO TO MOUTH SLIGHTLY OPEN POSITION
    delay(150);                       // waits 150ms for the servo to reach the position
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION
    digitalWrite(eyes,LOW);           //TURN OFF THE EYES
    }    

void three(){
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION  
    digitalWrite(eyes,HIGH);          //TURN OFF THE EYES
    myDFPlayer.play(3);               //Play the third mp3
    myservo.write(50);                //SET SERVO TO MOUTH OPEN POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(10);                //SET SERVO TO MOUTH SLIGHTLY OPEN POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(50);                //SET SERVO TO MOUTH OPEN POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION
    delay(200);                       // waits 200ms for the servo to reach the position
    myservo.write(10);                //SET SERVO TO MOUTH SLIGHTLY OPEN POSITION
    delay(150);                       // waits 150ms for the servo to reach the position
    myservo.write(100);               //SET SERVO TO MOUTH CLOSED POSITION
    digitalWrite(eyes,LOW);           //TURN OFF THE EYES
    }
